/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/p6invocation.pmc'
 * by ../../../../usr/lib/parrot/1.6.0/tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#define PARROT_IN_EXTENSION
#define CONST_STRING(i, s) Parrot_str_new_constant((i), s)
#define CONST_STRING_GEN(i, s) Parrot_str_new_constant((i), s)
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_p6invocation.h"
#include "pmc_default.h"
#include "pmc_continuation.h"
/*
$Id$
Copyright (C) 2009, The Perl Foundation.

=head1 NAME

src/pmc/P6Invocation.pmc - PMC representing a current invocation

=head1 DESCRIPTION

When we invoke a method in Perl 6, we need to keep the list of candidates
available for callwith, callsame, nextwith, nextsame etc. This PMC is what
gets stuck into the lex pad to represent the the candidate list.

=head2 Methods

=cut

*/

#include "parrot/parrot.h"
#include "pmc_perl6multisub.h"


/* Selects whether we're doing a real dispatch or just a test to see if
 * we could dispatch. */
#define P6I_MODE_DISPATCH 0
#define P6I_MODE_CHECK    1


/* Flag on the PMC to say whether we're in quiet failure mode (if set)
 * or exception mode if we are unable to dispatch. */
#define PObj_P6I_FAILURE_MODE_FLAG PObj_private0_FLAG


/* Declaration; definition of this is in p6opaque.pmc. */
PMC *look_for_method(PARROT_INTERP, PMC *search_list, INTVAL *start_pos, STRING *name);

/* Another declaration; this one is defined in perl6multisub.pmc. */
PMC *get_all_candidates_with_cur_args(PARROT_INTERP, PMC *self);


/* This does the grunt work of working out what the next candidate is. Takes
 * account of us maybe needing to look into multi variants and all that lot. */
static PMC *get_next_candidate(PARROT_INTERP, PMC *SELF, int check_only) {
    PMC    *candidates, *current, *search_list;
    STRING *name;
    INTVAL  position, resume_point;

    /* Get candidates and position. */
    GETATTR_P6Invocation_candidate_list(interp, SELF, candidates);
    GETATTR_P6Invocation_position(interp, SELF, position);

    /* Make sure we're not past the end of the candidate list. */
  check_and_continue_search:
    if (PMC_IS_NULL(candidates) || position >= VTABLE_elements(interp, candidates)) {
        /* Past the end; see if we've got a way to resume the search. */
        GETATTR_P6Invocation_search_list(interp, SELF, search_list);
        GETATTR_P6Invocation_name(interp, SELF, name);
        GETATTR_P6Invocation_resume_point(interp, SELF, resume_point);
        if (!PMC_IS_NULL(search_list) && name) {
            /* We can look for more candidates. Try to do so. */
            PMC *found = look_for_method(interp, search_list, &resume_point, name);
            SETATTR_P6Invocation_resume_point(interp, SELF, resume_point);
            if (PMC_IS_NULL(found))
                return PMCNULL;

            /* If we get here, we have more. Push this next candidate onto the
             * candidate list, creating it in the process if needed. */
            if (PMC_IS_NULL(candidates)) {
                candidates = pmc_new(interp, enum_class_ResizablePMCArray);
                SETATTR_P6Invocation_candidate_list(interp, SELF, candidates);
            }
            VTABLE_push_pmc(interp, candidates, found);
        }
        else {
            /* No way; give up. */
            return PMCNULL;
        }
    }

    /* Grab current candidate. */
    current = VTABLE_get_pmc_keyed_int(interp, candidates, position);
    if (VTABLE_isa(interp, current, CONST_STRING(interp, "Perl6MultiSub"))) {
        /* Multi. Ask the multi-dispatcher for all possible variants that we
         * could call with the current argument, unless we have none in
         * which we're just gonna have to leave the multi here in the list. */
        if (interp->current_args) {
            PMC *possibles = get_all_candidates_with_cur_args(interp, current);
            if (VTABLE_elements(interp, possibles) == 0) {
                /* No candidates here; increment the position, and then jump back
                 * to check if we need to find another candidate and try again or
                 * if the list is already containing more things for us to try. */
                position++;
                SETATTR_P6Invocation_position(interp, SELF, position);
                goto check_and_continue_search;
            }

            /* If we get here, we have some possibles; splice them into the candidate
             * list, then continue as normal. This means that deferal will take into
             * account the other multi-variants. Then our current becomes the first
             * of the multi candidates. */
            VTABLE_splice(interp, candidates, possibles, position, 1);
            current = VTABLE_get_pmc_keyed_int(interp, candidates, position);
        }
    }

    /* Increment position in candidate list if we're in check mode, and we're done. */
    if (!check_only)
        position++;
    SETATTR_P6Invocation_position(interp, SELF, position);
    return current;
}
static  PMC  * Parrot_P6Invocation_clone(PARROT_INTERP, PMC *pmc);
static  void  Parrot_P6Invocation_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_P6Invocation_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_P6Invocation_get_integer(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_P6Invocation_get_iter(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_P6Invocation_get_pmc(PARROT_INTERP, PMC *pmc);
static  void  Parrot_P6Invocation_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_P6Invocation_init_pmc(PARROT_INTERP, PMC *pmc, PMC *list);
static  opcode_t  * Parrot_P6Invocation_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  void  Parrot_P6Invocation_mark(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_P6Invocation_shift_pmc(PARROT_INTERP, PMC *pmc);
static  void Parrot_P6Invocation_nci_get(PARROT_INTERP, PMC *pmc);
static  void Parrot_P6Invocation_nci_trim_candidate_list(PARROT_INTERP, PMC *pmc);
static  void Parrot_P6Invocation_nci_set_failure_mode(PARROT_INTERP, PMC *pmc);
PARROT_DYNEXT_EXPORT void    Parrot_P6Invocation_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_P6Invocation_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_P6Invocation_get_vtable(PARROT_INTERP);
PARROT_DYNEXT_EXPORT void    Parrot_P6Invocation_ro_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_P6Invocation_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_P6Invocation_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_P6Invocation_clone(PARROT_INTERP, PMC *pmc)
{

    PMC *first_candidate, *candidate_list, *search_list;
    STRING *name;
    INTVAL position, resume_point;

    PMC *copy = pmc_new(interp, pmc->vtable->base_type);
    GETATTR_P6Invocation_first_candidate(interp, pmc, first_candidate);
    GETATTR_P6Invocation_candidate_list(interp, pmc, candidate_list);
    GETATTR_P6Invocation_position(interp, pmc, position);
    GETATTR_P6Invocation_search_list(interp, pmc, search_list);
    GETATTR_P6Invocation_name(interp, pmc, name);
    GETATTR_P6Invocation_resume_point(interp, pmc, resume_point);
    SETATTR_P6Invocation_first_candidate(interp, copy, first_candidate);
    SETATTR_P6Invocation_candidate_list(interp, copy, candidate_list);
    SETATTR_P6Invocation_position(interp, copy, position);
    SETATTR_P6Invocation_search_list(interp, copy, search_list);
    SETATTR_P6Invocation_name(interp, copy, name);
    SETATTR_P6Invocation_resume_point(interp, copy, resume_point);
    if (PObj_flag_TEST(P6I_FAILURE_MODE, pmc))
        PObj_flag_SET(P6I_FAILURE_MODE, copy);
    return copy;
}
static  void 
Parrot_P6Invocation_destroy(PARROT_INTERP, PMC *pmc)
{

    mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
}
static  INTVAL 
Parrot_P6Invocation_get_bool(PARROT_INTERP, PMC *pmc)
{

    PMC    *first_candidate, *candidates;
    INTVAL  position;

    /* First, check if we have a first candidate. */
    GETATTR_P6Invocation_first_candidate(interp, pmc, first_candidate);
    if (!PMC_IS_NULL(first_candidate))
        return 1;

    /* Get candidates and position, and check if we have more candidates
     * already known about. */
    GETATTR_P6Invocation_candidate_list(interp, pmc, candidates);
    GETATTR_P6Invocation_position(interp, pmc, position);
    if (!PMC_IS_NULL(candidates) && position < VTABLE_elements(interp, candidates))
        return 1;

    /* If not, then we see if the dispatcher can potentially find more. */
    return !PMC_IS_NULL(get_next_candidate(interp, pmc, P6I_MODE_CHECK));
}
static  INTVAL 
Parrot_P6Invocation_get_integer(PARROT_INTERP, PMC *pmc)
{

    return VTABLE_get_bool(interp, pmc);
}
static  PMC  *
Parrot_P6Invocation_get_iter(PARROT_INTERP, PMC *pmc)
{

    return VTABLE_clone(interp, pmc);
}
static  PMC  *
Parrot_P6Invocation_get_pmc(PARROT_INTERP, PMC *pmc)
{

    PMC *first_candidate;
    PMC *clone = VTABLE_clone(interp, pmc);
    GETATTR_P6Invocation_first_candidate(interp, clone, first_candidate);
    if (PMC_IS_NULL(first_candidate))
        first_candidate = get_next_candidate(interp, clone, P6I_MODE_CHECK);
    return first_candidate;
}
static  void 
Parrot_P6Invocation_init(PARROT_INTERP, PMC *pmc)
{

    PMC_data(pmc) = mem_allocate_zeroed_typed(Parrot_P6Invocation_attributes);
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);
}
static  void 
Parrot_P6Invocation_init_pmc(PARROT_INTERP, PMC *pmc, PMC *list)
{

    VTABLE_init(interp, pmc);
    SETATTR_P6Invocation_candidate_list(interp, pmc, list);
}
static  opcode_t  *
Parrot_P6Invocation_invoke(PARROT_INTERP, PMC *pmc, void *next)
{

    STRING   *lexname = CONST_STRING(interp, "__CANDIDATE_LIST__");
    PMC      *lexpad, *first_candidate;
    opcode_t *addr;

    /* In the straightforward case, we know our first candidate right off the
     * bat; if not, use list. We also nullify first candidate so we hit the
     * candidate list next time we're used. */
    GETATTR_P6Invocation_first_candidate(interp, pmc, first_candidate);
    if (PMC_IS_NULL(first_candidate))
        first_candidate = get_next_candidate(interp, pmc, P6I_MODE_DISPATCH);
    else
        SETATTR_P6Invocation_first_candidate(interp, pmc, PMCNULL);

    /* Invoke it, then fudge ourself into its lexpad. */
    if (PMC_IS_NULL(first_candidate)) {
        PMC *ns;

        /* Oh noes, no candidate. If we aren't in soft-fail mode, then
         * throw an exception. */
        if (!PObj_flag_TEST(P6I_FAILURE_MODE, pmc))
            Parrot_ex_throw_from_c_args(interp, next, 1, "No candidates found to invoke");

        /* Otherwise, we look up something that when invoked will just give a
         * dispatch failure. */
        ns = Parrot_get_namespace_keyed_str(interp, interp->root_namespace, CONST_STRING(interp, "perl6"));
        first_candidate = VTABLE_get_pmc_keyed_str(interp, ns, CONST_STRING(interp, "!deferal_fail"));
    }
    addr = VTABLE_invoke(interp, first_candidate, next);
    lexpad = Parrot_pcc_get_lex_pad(interp, CURRENT_CONTEXT(interp));
    if (!PMC_IS_NULL(lexpad) && VTABLE_exists_keyed_str(interp, lexpad, lexname))
        VTABLE_set_pmc_keyed_str(interp, lexpad, lexname, pmc);
    return addr;
}
static  void 
Parrot_P6Invocation_mark(PARROT_INTERP, PMC *pmc)
{

    if (PMC_data(pmc)) {
        PMC *first_candidate, *candidate_list, *search_list;
        STRING *name;
        GETATTR_P6Invocation_first_candidate(interp, pmc, first_candidate);
        GETATTR_P6Invocation_candidate_list(interp, pmc, candidate_list);
        GETATTR_P6Invocation_search_list(interp, pmc, search_list);
        GETATTR_P6Invocation_name(interp, pmc, name);
        if (!PMC_IS_NULL(first_candidate))
            Parrot_gc_mark_PObj_alive(interp, (PObj*)first_candidate);
        if (!PMC_IS_NULL(candidate_list))
            Parrot_gc_mark_PObj_alive(interp, (PObj*)candidate_list);
        if (!PMC_IS_NULL(search_list))
            Parrot_gc_mark_PObj_alive(interp, (PObj*)search_list);
        if (name)
            Parrot_gc_mark_PObj_alive(interp, (PObj*)name);
    }
}
static  PMC  *
Parrot_P6Invocation_shift_pmc(PARROT_INTERP, PMC *pmc)
{

    /* Result is a clone of ourself. We clone ourself rather than handing
     * back the method so invocations of it that defer will work out. */
    PMC *result = VTABLE_clone(interp, pmc);

    /* Now shuffle along one candidate. */
    PMC *first_candidate;
    GETATTR_P6Invocation_first_candidate(interp, pmc, first_candidate);
    if (PMC_IS_NULL(first_candidate))
        get_next_candidate(interp, pmc, P6I_MODE_DISPATCH);
    else
        SETATTR_P6Invocation_first_candidate(interp, pmc, PMCNULL);

    return result;
}
static  void
Parrot_P6Invocation_nci_get(PARROT_INTERP, PMC *pmc)
{
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;



    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(_ctx, 0);


    /* BEGIN PMETHOD BODY */
    {

    PMC *result = VTABLE_shift_pmc(interp, pmc);
        {
    /*BEGIN RETURN PMC *result */
    /*BEGIN GENERATED ACCESSORS */
    CTX_REG_PMC(_ctx, 0) = result;

    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_returns;
    /*END RETURN PMC *result */
    }


    }
    goto no_return;
    /* END PMETHOD BODY */

get_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
}
static  void
Parrot_P6Invocation_nci_trim_candidate_list(PARROT_INTERP, PMC *pmc)
{
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;



    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(_ctx, 0);


    /* BEGIN PMETHOD BODY */
    {

    /* Just blank out everything we could use to find another
     * method. */
    SETATTR_P6Invocation_candidate_list(interp, pmc, PMCNULL);
    SETATTR_P6Invocation_position(interp, pmc, 0);
    SETATTR_P6Invocation_name(interp, pmc, NULL);
    SETATTR_P6Invocation_search_list(interp, pmc, PMCNULL);
    SETATTR_P6Invocation_resume_point(interp, pmc, 0);

    }
    goto no_return;
    /* END PMETHOD BODY */


    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
}
static  void
Parrot_P6Invocation_nci_set_failure_mode(PARROT_INTERP, PMC *pmc)
{
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;



    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(_ctx, 0);


    /* BEGIN PMETHOD BODY */
    {

    PObj_flag_SET(P6I_FAILURE_MODE, pmc);

    }
    goto no_return;
    /* END PMETHOD BODY */


    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
}
#include "pmc_default.h"

PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_P6Invocation_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_P6Invocation_clone;
    vt->destroy = Parrot_P6Invocation_destroy;
    vt->get_bool = Parrot_P6Invocation_get_bool;
    vt->get_integer = Parrot_P6Invocation_get_integer;
    vt->get_iter = Parrot_P6Invocation_get_iter;
    vt->get_pmc = Parrot_P6Invocation_get_pmc;
    vt->init = Parrot_P6Invocation_init;
    vt->init_pmc = Parrot_P6Invocation_init_pmc;
    vt->invoke = Parrot_P6Invocation_invoke;
    vt->mark = Parrot_P6Invocation_mark;
    vt->shift_pmc = Parrot_P6Invocation_shift_pmc;
    vt->attr_size = 0;

    return vt;
}


PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_P6Invocation_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_P6Invocation_clone;
    vt->destroy = Parrot_P6Invocation_destroy;
    vt->get_bool = Parrot_P6Invocation_get_bool;
    vt->get_integer = Parrot_P6Invocation_get_integer;
    vt->get_iter = Parrot_P6Invocation_get_iter;
    vt->get_pmc = Parrot_P6Invocation_get_pmc;
    vt->init = Parrot_P6Invocation_init;
    vt->init_pmc = Parrot_P6Invocation_init_pmc;
    vt->invoke = Parrot_P6Invocation_invoke;
    vt->mark = Parrot_P6Invocation_mark;
    vt->attr_size = 0;

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_P6Invocation_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_P6Invocation_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_P6Invocation_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_P6Invocation_ro_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_P6Invocation_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "P6Invocation", 12, NULL, 0));
    return mro;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_P6Invocation_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "P6Invocation")), PMCNULL);
    return isa;
}

void
Parrot_P6Invocation_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Ffirst_candidate Fcandidate_list Iposition Sname Fsearch_list Iresume_point ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_P6Invocation_get_vtable(interp);
        vt->base_type      = -1;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->base_type    = entry;
        vt->whoami       = string_make(interp, "P6Invocation", 12,
                                       "ascii", PObj_constant_FLAG|PObj_external_FLAG);
        vt->provides_str = Parrot_str_append(interp, vt->provides_str,
            string_make(interp, "scalar", 6, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG));

        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_P6Invocation_ro_get_vtable(interp);
            vt_ro->base_type      = -1;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_P6Invocation_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_P6Invocation_nci_get), CONST_STRING_GEN(interp, "get"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_P6Invocation_nci_trim_candidate_list), CONST_STRING_GEN(interp, "trim_candidate_list"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_P6Invocation_nci_set_failure_mode), CONST_STRING_GEN(interp, "set_failure_mode"));
        {
        }
    } /* pass */
} /* Parrot_P6Invocation_class_init */
/*
 * This load function will be called to do global (once) setup
 * whatever is needed to get this extension running
 */


PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_p6invocation_load(PARROT_INTERP); /* don't warn */
PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_p6invocation_load(PARROT_INTERP)
{
    Parrot_String whoami;
    Parrot_PMC    pmc;
    Parrot_Int typeP6Invocation;
    int pass;

    /* create a library PMC */
    pmc = constant_pmc_new(interp, enum_class_ParrotLibrary);

    /* TODO: stuff some info into this PMC's props */

    /* for all PMCs we want to register: */
    whoami = CONST_STRING_GEN(interp, "P6Invocation");
    typeP6Invocation = pmc_register(interp, whoami);

    /* do class_init code */
    for (pass = 0; pass <= 1; ++pass) {
        Parrot_P6Invocation_class_init(interp, typeP6Invocation, pass);
    }
    return pmc;
}


