/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/perl6multisub.pmc'
 * by ../../../../usr/lib/parrot/1.6.0/tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#define PARROT_IN_EXTENSION
#define CONST_STRING(i, s) Parrot_str_new_constant((i), s)
#define CONST_STRING_GEN(i, s) Parrot_str_new_constant((i), s)
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_perl6multisub.h"
#include "pmc_multisub.h"
#include "pmc_resizablepmcarray.h"
#include "pmc_fixedpmcarray.h"
#include "pmc_default.h"
#include "pmc_continuation.h"
/*
$Id$
Copyright (C) 2008-2009, The Perl Foundation.

=head1 NAME

src/pmc/perl6multisub.pmc - Perl 6 MultiSub PMC

=head1 DESCRIPTION

Subclass of MultiSub that overrides invoke to implement the Perl 6 multiple
dispatch algorithm, along with providing various other pieces.

Since we need to store some extra information, we cannot just actually be
a ResizablePMCArray, but rather we need to have one.

=head1 TODO

This is a list of things that I need to deal with/come back and worry about
later (it's not a complete todo list for finishing up the PMC itself, just
of fixup tasks in what is already done).

=over 4

=item Use Perl 6 types when boxing native arguments in the arg list

=item Make sure we override everything that ResizablePMCArray and its parents
would provide us with. Otherwise, we'll just get segfaults 'cus we don't store
stuff the way it does.

=back

=head1 INTERNAL STRUCTURES

We have some structures that we use to keep data around internally.

=over 4

=item candidate_info

Represents a candidate. We extract various bits of information about it when
we are building the sorted candidate list and store them in here for fast
access during a dispatch.

*/

#include "parrot/oplib/ops.h"


typedef struct candidate_info {
    PMC   *sub;         /* The sub that is the candidate. */
    PMC  **types;       /* Class or role type constraints for each parameter. */
    PMC  **constraints; /* Refinement type constraints for each parameter
                         * (if there are many, this will be a junction). */
    INTVAL num_types;   /* Number of entries in the above two arrays. */
    INTVAL min_arity;   /* The number of required positonal arguments. */
    INTVAL max_arity;   /* # of required and optional positional arguments. */
    INTVAL bind_check;  /* A true value if any parameters have constraints and/or are named. */
} candidate_info;

/*

=item candidate_graph_node

Represents the produced information about a candidate as well as the graph
edges originating from it. The edges array contains pointers to the edges
in the graph that we have arrows to.

*/

typedef struct candidate_graph_node {
    candidate_info               *info;
    struct candidate_graph_node **edges;
    INTVAL                        edges_in;
    INTVAL                        edges_out;
} candidate_graph_node;


/* Some constants for candidate sorter. */
#define EDGE_REMOVAL_TODO -1
#define EDGE_REMOVED      -2

/* Some constants for the dispatcher. */
#define MMD_ONE_RESULT   0
#define MMD_MANY_RESULTS 1

/* Special value we set arity to when we have a slurpy. */
#define SLURPY_ARITY     1 << 30

/*

=back

=head1 FUNCTIONS

These are worker functions used by the methods of the PMC, and not visible
from the outside.

=over 4

=item C<static void get_args(PARROT_INTERP, PMC **pos_args, PMC **named_args)>

Gets a list of the arguments that are being passed, taking them from the
registers and the constants table and flattening any :flat arguments as
required. Hands back a ResizablePMCArray of the positional parameters and
a Hash of the named parameters.

=cut

*/

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static void
get_args(PARROT_INTERP, PMC **pos_args, PMC **named_args)
{
    INTVAL sig_len, i;
    PMC    *arg;
    PMC    *sig;
    STRING *name      = NULL;

    /* Initialize results list. */
    PMC    * const arg_list       = pmc_new(interp, enum_class_ResizablePMCArray);
    PMC    * const arg_hash       = pmc_new(interp, enum_class_Hash);

    /* Get constants table for current segment, so we can look up sig and any
     * constant arguments. */
    PackFile_Constant **constants = interp->code->const_table->constants;

    /* Make sure we have a place to source the current arguments from. */
    const opcode_t *args_op = interp->current_args;
    if (!args_op)
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "No arguments found to dispatch on");
    PARROT_ASSERT(*args_op == PARROT_OP_set_args_pc);

    /* Get the (Parrot calling conventions) signature PMC. */
    ++args_op;
    sig = constants[*args_op]->u.key;
    ASSERT_SIG_PMC(sig);
    sig_len = VTABLE_elements(interp, sig);

    /* Set PMC arguments. */
    *pos_args   = arg_list;
    *named_args = arg_hash;

    /* If we have a zero-length signature, we're done. */
    if (sig_len == 0)
        return;

    /* Otherwise, we have arguments. */
    ++args_op;
    for (i = 0; i < sig_len; ++i, ++args_op) {
        const INTVAL type = VTABLE_get_integer_keyed_int(interp, sig, i);
        const int idx     = *args_op;

        /* If we find a named argument, grab its name; the next thing will
         * be the value. */
        if ((type & PARROT_ARG_NAME) && !(type & PARROT_ARG_FLATTEN)) {
            name = constants[idx]->u.string;
            continue;
        }

        /* Put the argument in the list. For some arguments, we must box them into
         * a PMC to be able to have them in the list. XXX Use Perl 6 box types. */
        switch (type & (PARROT_ARG_TYPE_MASK | PARROT_ARG_FLATTEN | PARROT_ARG_NAME)) {
            case PARROT_ARG_INTVAL:
                /* Integer constants always in register. */
                arg = pmc_new(interp, enum_class_Integer);
                VTABLE_set_integer_native(interp, arg, REG_INT(interp, idx));
                if (name)
                    VTABLE_set_pmc_keyed_str(interp, arg_hash, name, arg);
                else
                    VTABLE_push_pmc(interp, arg_list, arg);
                break;
            case PARROT_ARG_FLOATVAL:
                /* May have value in an N register or constants table. */
                arg = pmc_new(interp, enum_class_Float);
                if ((type & PARROT_ARG_CONSTANT))
                    VTABLE_set_number_native(interp, arg, constants[idx]->u.number);
                else
                    VTABLE_set_number_native(interp, arg, REG_NUM(interp, idx));
                if (name)
                    VTABLE_set_pmc_keyed_str(interp, arg_hash, name, arg);
                else
                    VTABLE_push_pmc(interp, arg_list, arg);
                break;
            case PARROT_ARG_STRING:
                /* May have value in an S register or constnats table. */
                arg = pmc_new(interp, enum_class_String);
                if ((type & PARROT_ARG_CONSTANT))
                    VTABLE_set_string_native(interp, arg, constants[idx]->u.string);
                else
                    VTABLE_set_string_native(interp, arg, REG_STR(interp, idx));
                if (name)
                    VTABLE_set_pmc_keyed_str(interp, arg_hash, name, arg);
                else
                    VTABLE_push_pmc(interp, arg_list, arg);
                break;
            case PARROT_ARG_PMC:
                /* May have value in a P register or constants table. */
                if ((type & PARROT_ARG_CONSTANT))
                    arg = constants[idx]->u.key;
                else
                    arg = REG_PMC(interp, idx);
                if (name)
                    VTABLE_set_pmc_keyed_str(interp, arg_hash, name, arg);
                else
                    VTABLE_push_pmc(interp, arg_list, arg);
                break;
            case PARROT_ARG_FLATTEN | PARROT_ARG_PMC: {
                /* Expand flattening arguments; just loop over the array that
                 * is being flattened and get all of the entries within it. */
                int j, n;
                const int idx = *args_op;
                arg           = REG_PMC(interp, idx);
                n             = VTABLE_elements(interp, arg);
                for (j = 0; j < n; ++j)
                    VTABLE_push_pmc(interp, arg_list,
                        VTABLE_get_pmc_keyed_int(interp, arg, j));
                break;
            }
            case PARROT_ARG_FLATTEN | PARROT_ARG_PMC | PARROT_ARG_NAME: {
                /* Expand flattening arguments; iterate over the hash. */
                const int idx = *args_op;
                PMC *it;
                arg           = REG_PMC(interp, idx);
                it            = VTABLE_get_iter(interp, arg);
                while (VTABLE_get_bool(interp, it)) {
                    name = VTABLE_shift_string(interp, it);
                    VTABLE_set_pmc_keyed_str(interp, arg_hash, name,
                            VTABLE_get_pmc_keyed_str(interp, arg, name));
                }
                break;
            }
            default:
                Parrot_ex_throw_from_c_args(interp, NULL, 1,
                        "Unknown signature type %d in Parrot_Perl6MultiSub_get_args", type);
                break;
        }
    }
}


/*

=item C<static INTVAL is_narrower(PARROT_INTERP, candidate_info *a, candidate_info *b)>

Takes two candidates and determines if the first one is narrower than the
second. Returns a true value if they are.

=cut

*/
static INTVAL is_narrower(PARROT_INTERP, candidate_info *a, candidate_info *b) {
    STRING * const ACCEPTS = CONST_STRING(interp, "ACCEPTS");
    INTVAL narrower = 0;
    INTVAL tied = 0;
    INTVAL i, types_to_check;

    /* Work out how many parameters to compare, factoring in slurpiness
     * and optionals. */
    if (a->num_types == b->num_types)
        types_to_check = a->num_types;
    else if (a->min_arity == b->min_arity)
        types_to_check = a->num_types > b->num_types ? b->num_types : a->num_types;
    else
        return 0;

    /* Analyse each parameter in the two candidates. */
    for (i = 0; i < types_to_check; i++) {
        PMC * const type_obj_a = a->types[i];
        PMC * const type_obj_b = b->types[i];
        if (type_obj_a == type_obj_b) {
            /* Same type; narrower if first has constraints and other doesn't;
             * tied if neither has constraints or both have constraints. */
            if (!PMC_IS_NULL(a->constraints[i]) && PMC_IS_NULL(b->constraints[i]))
                narrower++;
            else if (PMC_IS_NULL(a->constraints[i]) && PMC_IS_NULL(b->constraints[i]) ||
                     !PMC_IS_NULL(a->constraints[i]) && !PMC_IS_NULL(b->constraints[i]))
                tied++;
        }
        else {
            PMC * const accepts_meth_a = VTABLE_find_method(interp, type_obj_b, ACCEPTS);
            PMC * const result_n = (PMC *) Parrot_run_meth_fromc_args(interp, accepts_meth_a,
                    type_obj_b, ACCEPTS, "PP", type_obj_a);
            if (VTABLE_get_integer(interp, result_n)) {
                /* Narrower - note it and we're done. */
                narrower++;
            }
            else {
                /* Make sure it's tied, rather than the other way around. */
                PMC * const accepts_meth_b = VTABLE_find_method(interp, type_obj_a, ACCEPTS);
                PMC * const result_w = (PMC *) Parrot_run_meth_fromc_args(interp,
                        accepts_meth_b, type_obj_a,
                        ACCEPTS, "PP", type_obj_b);
                if (!VTABLE_get_integer(interp, result_w)) {
                    tied++;
                }
            }
        }
    }

    /* If one is narrower than the other from current analysis, we're done. */
    if (narrower >= 1 && narrower + tied == types_to_check)
        return 1;

    /* If they aren't tied, we're also done. */
    else if (tied != types_to_check)
        return 0;

    /* Otherwise, we see if one has a slurpy and the other not. A lack of
     * slurpiness makes the candidate narrower. Otherwise, they're tied. */
    return a->max_arity != SLURPY_ARITY && b->max_arity == SLURPY_ARITY;
}


/*

=item C<static candidate_info** sort_candidates(PMC *candidates)>

Takes a ResizablePMCArray of the candidates, collects information about them
and then does a topological sort of them.

=cut

*/
static candidate_info** sort_candidates(PARROT_INTERP, PMC *candidates, PMC **proto_out) {
    INTVAL i;
    PMC    *found_proto = PMCNULL;
    const char *error = NULL;

    /* Allocate results array (just allocate it for worst case, which
     * is no ties ever, so a null between all of them, and then space
     * for the terminating null. */
    INTVAL num_candidates = VTABLE_elements(interp, candidates);
    candidate_info** const result = mem_allocate_n_zeroed_typed(
            2 * num_candidates + 1, candidate_info*);

    /* Create a node for each candidate in the graph. */
    candidate_graph_node** const graph = mem_allocate_n_zeroed_typed(
            num_candidates, candidate_graph_node*);
    INTVAL insert_pos = 0;
    for (i = 0; i < num_candidates; i++) {
        PMC *signature;
        PMC *params;
        PMC *meth;
        candidate_info *info;
        INTVAL sig_elems;
        INTVAL j;
        INTVAL significant_param;

        /* Get information about this candidate. */
        PMC * const candidate = VTABLE_get_pmc_keyed_int(interp, candidates, i);
        PMC * const proto     = VTABLE_getprop(interp, candidate, CONST_STRING(interp, "proto"));

        /* Is it a proto? */
        if (!PMC_IS_NULL(proto) && VTABLE_get_bool(interp, proto)) {
            if (PMC_IS_NULL(found_proto))
                found_proto = candidate;
            else
                error = "Can only have one proto in a single scope.";
            continue;
        }

        /* Otherwise, need an entry. */
        info = mem_allocate_zeroed_typed(candidate_info);
        info->sub = candidate;

        /* Arity. */
        info->min_arity = VTABLE_get_integer(interp,
                VTABLE_inspect_str(interp, candidate, CONST_STRING(interp, "pos_required")));
        if (VTABLE_get_integer(interp, VTABLE_inspect_str(interp, candidate,
               CONST_STRING(interp, "pos_slurpy"))))
            info->max_arity = SLURPY_ARITY;
        else
            info->max_arity = info->min_arity + VTABLE_get_integer(interp,
                    VTABLE_inspect_str(interp, candidate, CONST_STRING(interp, "pos_optional")));

        /* Type information. */
        signature         = VTABLE_getprop(interp, candidate, CONST_STRING(interp, "$!signature"));
        meth              = VTABLE_find_method(interp, signature, CONST_STRING(interp, "params"));
        params            = (PMC*)Parrot_run_meth_fromc_args(interp, meth, signature,
                CONST_STRING(interp, "params"), "P");
        sig_elems         = VTABLE_elements(interp, params);
        info->types       = mem_allocate_n_zeroed_typed(sig_elems + 1, PMC*);
        info->constraints = mem_allocate_n_zeroed_typed(sig_elems + 1, PMC*);
        significant_param = 0;
        for (j = 0; j < sig_elems; j++) {
            /* Look up various bits from the signature. */
            PMC * const param       = VTABLE_get_pmc_keyed_int(interp, params, j);
            PMC * const type        = VTABLE_get_pmc_keyed_str(interp, param,
                    CONST_STRING(interp, "nom_type"));
            PMC * const constraints = VTABLE_get_pmc_keyed_str(interp, param,
                    CONST_STRING(interp, "cons_type"));
            PMC * const multi_inv   = VTABLE_get_pmc_keyed_str(interp, param,
                    CONST_STRING(interp, "multi_invocant"));
            PMC * const named       = VTABLE_get_pmc_keyed_str(interp, param,
                    CONST_STRING(interp, "named"));
            PMC * const slurpy      = VTABLE_get_pmc_keyed_str(interp, param,
                    CONST_STRING(interp, "slurpy"));

            /* If it's named, and not slurpy, don't need its type info but we will
             * need a bindability check during the dispatch for it. */
            if (!PMC_IS_NULL(named) && PMC_IS_NULL(slurpy)) {
                info->bind_check = 1;
                continue;
            }

            /* Record type info for this parameter. */
            info->types[significant_param] = type;
            info->constraints[significant_param] = constraints;
            if (!PMC_IS_NULL(constraints))
                info->bind_check = 1;
            if (!PMC_IS_NULL(multi_inv) && VTABLE_get_bool(interp, multi_inv))
                info->num_types++;
            significant_param++;
        }

        /* Add it to graph node, and initialize list of edges. */
        graph[insert_pos] = mem_allocate_zeroed_typed(candidate_graph_node);
        graph[insert_pos]->info = info;
        graph[insert_pos]->edges = mem_allocate_n_zeroed_typed(
            num_candidates, candidate_graph_node*);
        insert_pos++;
    }

    /* If we found duplicate protos, don't go any further. */
    if (!error) {
        INTVAL candidates_to_sort;
        INTVAL result_pos;

        /* The actual number of candidates needs to discount any protos. */
        num_candidates = insert_pos;

        /* Now analyze type narrowness of the candidates relative to each other
         * and create the edges. */
        for (i = 0; i < num_candidates; i++) {
            INTVAL j;
            for (j = 0; j < num_candidates; j++) {
                if (i == j)
                    continue;
                if (is_narrower(interp, graph[i]->info, graph[j]->info)) {
                    graph[i]->edges[graph[i]->edges_out] = graph[j];
                    graph[i]->edges_out++;
                    graph[j]->edges_in++;
                }
            }
        }

        /* Perform the topological sort. */
        candidates_to_sort = num_candidates;
        result_pos = 0;
        while (candidates_to_sort > 0) {
            const INTVAL rem_start_point = result_pos;

            /* Find any nodes that have no incoming edges and add them to results. */
            for (i = 0; i < num_candidates; i++) {
                if (graph[i]->edges_in == 0) {
                    /* Add to results. */
                    result[result_pos] = graph[i]->info;
                    result_pos++;
                    candidates_to_sort--;
                    graph[i]->edges_in = EDGE_REMOVAL_TODO;
                }
            }
            if (rem_start_point == result_pos) {
                error = "Circularity detected in multi sub types.";
                break;
            }

            /* Now we need to decrement edges in counts for things that had edges
             * from candidates we added here. */
            for (i = 0; i < num_candidates; i++) {
                if (graph[i]->edges_in == EDGE_REMOVAL_TODO) {
                    INTVAL j;
                    for (j = 0; j < graph[i]->edges_out; j++)
                        graph[i]->edges[j]->edges_in--;
                    graph[i]->edges_in = EDGE_REMOVED;
                }
            }

            /* This is end of a tied group, so leave a gap. */
            result_pos++;
        }
    }

    /* Free memory associated with the graph. */
    for (i = 0; i < num_candidates; i++) {
        if (error)
            mem_sys_free(graph[i]->info);
        mem_sys_free(graph[i]->edges);
        mem_sys_free(graph[i]);
    }
    mem_sys_free(graph);

    /* If we had an error, free memory for result array and throw exception. */
    if (error) {
        mem_sys_free(result);
        Parrot_ex_throw_from_c_args(interp, 0, 1, error);
    }

    *proto_out = found_proto;
    return result;
}


/*

=item C<static INTVAL has_junctional_args(PARROT_INTERP, PMC *args)>

Checks if any of the args are junctional.

=cut

*/

static INTVAL has_junctional_args(PARROT_INTERP, PMC *args) {
    const INTVAL num_args   = VTABLE_elements(interp, args);
    STRING * const junction = CONST_STRING(interp, "Junction");
    INTVAL i;

    for (i = 0; i < num_args; i++) {
        PMC * const arg = VTABLE_get_pmc_keyed_int(interp, args, i);
        if (VTABLE_isa(interp, arg, junction))
            return 1;
    }
    return 0;
}


/*

=item C<static PMC* do_dispatch(PARROT_INTERP, PMC *self, candidate_info **candidates,
                                PMC *proto, PMC *pos_args, PMC *named_args, int many,
                                int num_candidates, opcode_t *next, MMD_Cache *cache)>

Runs the Perl 6 MMD algorithm. If many is set to a true value, returns a
ResizablePMCArray of all possible candidates, which may be empty. If many
is false, then returns either the one winning unambiguous candidate
or throws an error saying that the dispatch failed if there were no
candidates or that it was ambiguous if there were tied candidates.

=cut

*/

static PMC* do_dispatch(PARROT_INTERP, PMC *self, candidate_info **candidates, PMC *proto,
        PMC *pos_args, PMC *named_args, int many, int num_candidates, opcode_t *next,
        MMD_Cache *cache) {
    INTVAL           type_mismatch;
    STRING * const   ACCEPTS          = CONST_STRING(interp, "ACCEPTS");
    INTVAL           possibles_count  = 0;
    const INTVAL     num_args         = VTABLE_elements(interp, pos_args);
    candidate_info **cur_candidate    = candidates;
    candidate_info **possibles        = mem_allocate_n_typed(num_candidates,
                                         candidate_info *);
    INTVAL           type_check_count;
    PMC             *junctional_res   = PMCNULL;
    INTVAL           pure_type_result = 1;

    /* Iterate over the candidates and collect best ones; terminate
     * when we see two nulls (may break out earlier). */
    while (1) {
        INTVAL i;

        if (*cur_candidate == NULL) {
            /* We've hit the end of a tied group now. If any of them have a
             * bindability check requirement, we'll do any of those now. */
            if (possibles_count) {
                PMC *checker = Parrot_find_global_n(interp, Parrot_get_ctx_HLL_namespace(interp),
                        CONST_STRING(interp, "!bindability_checker"));
                PMC *bind_check_result;
                candidate_info **new_possibles = NULL;
                INTVAL new_possibles_count = 0;
                INTVAL i;

                for (i = 0; i < possibles_count; i++) {
                    if (possibles[i]->bind_check) {
                        /* We have one that needs a bindability check. Thus this will
                         * not be a pure nominal type result. */
                        pure_type_result = 0;

                        /* Run the bindability check. */
                        bind_check_result = Parrot_runops_fromc_args(interp, checker, "PPPP",
                                possibles[i]->sub, pos_args, named_args);

                        /* If we haven't got a possibles storage space, allocate it now. */
                        if (!new_possibles)
                            new_possibles = mem_allocate_n_typed(num_candidates, candidate_info *);

                        /* If we got a non-null result, need to put this one onto the list.
                         * XXX actually we should keep around the resume cont that we get
                         * here and invoke that to avoid dupe type checks. */
                        if (!PMC_IS_NULL(bind_check_result)) {
                            new_possibles[new_possibles_count] = possibles[i];
                            new_possibles_count++;
                        }
                    }
                }

                /* If we have an updated list of possibles, free old one and use this
                 * new one from here on in. */
                if (new_possibles) {
                    mem_sys_free(possibles);
                    possibles = new_possibles;
                    possibles_count = new_possibles_count;
                }
            }

            /* Now we have eliminated any that fail the bindability check. If
             * we're looking for just one result, we now have it so we can stop. */
            if (many == MMD_ONE_RESULT && possibles_count)
                break;

            /* Otherwise, we keep looping and looking, unless we really hit the end. */
            if (cur_candidate[1]) {
                cur_candidate++;
                continue;
            }
            else {
                break;
            }
        }

        /* Check if it's admissable by arity. */
        if (num_args < (*cur_candidate)->min_arity
        ||  num_args > (*cur_candidate)->max_arity) {
            cur_candidate++;
            continue;
        }

        /* Check if it's admissable by type. */
        type_check_count = (*cur_candidate)->num_types > num_args
                         ? num_args
                         : (*cur_candidate)->num_types;
        type_mismatch = 0;

        for (i = 0; i < type_check_count; i++) {
            PMC * const param        = VTABLE_get_pmc_keyed_int(interp, pos_args, i);
            PMC * const type_obj     = (*cur_candidate)->types[i];
            PMC * const accepts_meth = VTABLE_find_method(interp, type_obj, ACCEPTS);
            PMC * const result       = (PMC *)Parrot_run_meth_fromc_args(interp,
                                    accepts_meth, type_obj, ACCEPTS,
                                    "PP", param);

            if (!VTABLE_get_integer(interp, result)) {
                type_mismatch = 1;
                break;
            }
        }

        if (type_mismatch) {
            cur_candidate++;
            continue;
        }

        /* If we get here, it's an admissable candidate; add to list. */
        possibles[possibles_count] = *cur_candidate;
        possibles_count++;
        cur_candidate++;
    }

    /* Check is default trait if we still have multiple options and we want one. */
    if (possibles_count > 1) {
        /* Locate any default candidates; if we find multiple defaults, this is
         * no help, so we'll not bother collection just which ones are good. */
        candidate_info *default_cand = NULL;
        INTVAL i;

        for (i = 0; i < possibles_count; i++) {
            PMC * const default_prop = VTABLE_getprop(interp, possibles[i]->sub,
                    CONST_STRING(interp, "default"));
            if (!PMC_IS_NULL(default_prop)) {
                if (default_cand == NULL) {
                    default_cand = possibles[i];
                }
                else {
                    default_cand = NULL;
                    break;
                }
            }
        }
        if (default_cand) {
            possibles[0] = default_cand;
            possibles_count = 1;
        }
    }

    /* If we're at a single candidate here, and we are only looking for one, and we
     * also know there's no type constraints that follow, we can cache the result. */
    if (many == MMD_ONE_RESULT && possibles_count == 1 && pure_type_result) {
        if (!cache) {
            cache = Parrot_mmd_cache_create(interp);
            SETATTR_Perl6MultiSub_cache_single(interp, self, cache);
        }
        Parrot_mmd_cache_store_by_values(interp, cache, "", pos_args, possibles[0]->sub);
    }

    /* Perhaps we found nothing but have juncitonal arguments? */
    if (possibles_count == 0 && has_junctional_args(interp, pos_args)) {
        /* Look up multi junction dispatcher, clone it, attach this multi-sub
         * as a property and hand that back as the dispatch result. We also
         * stick it in the MMD cache for next time around. */
        PMC *sub = Parrot_find_global_n(interp, Parrot_get_ctx_HLL_namespace(interp),
                CONST_STRING(interp, "!DISPATCH_JUNCTION_MULTI"));
        sub = VTABLE_clone(interp, sub);
        VTABLE_setprop(interp, sub, CONST_STRING(interp, "sub"), self);
        if (cache && many == MMD_ONE_RESULT)
            Parrot_mmd_cache_store_by_values(interp, cache, "", pos_args, sub);
        junctional_res = sub;
    }

    if (!many) {
        /* Need a unique candidate. */
        if (possibles_count == 1) {
            PMC *result = possibles[0]->sub;
            mem_sys_free(possibles);
            return result;
        }
        else if (!PMC_IS_NULL(junctional_res)) {
            return junctional_res;
        }
        else if (!PMC_IS_NULL(proto)) {
            /* If we have a proto at this point, use that. */
            mem_sys_free(possibles);
            return proto;
        }
        else if (possibles_count == 0) {
            mem_sys_free(possibles);
            Parrot_ex_throw_from_c_args(interp, next, 1,
                "No applicable candidates found to dispatch to for '%Ss'",
                    VTABLE_get_string(interp, candidates[0]->sub));
        }
        else {
            /* Get signatures of ambiguous candidates. */
            STRING * const sig_name  = CONST_STRING(interp, "signature");
            STRING * const perl_name = CONST_STRING(interp, "perl");
            STRING * const newline   = CONST_STRING(interp, "\n");

            STRING *signatures       = Parrot_str_new(interp, "", 0);
            INTVAL i;

            for (i = 0; i < possibles_count; i++) {
                PMC    * const sig_meth  = VTABLE_find_method(interp, possibles[i]->sub, sig_name);
                PMC    * const sig_obj   = (PMC *)Parrot_run_meth_fromc_args(interp, sig_meth,
                        possibles[i]->sub, sig_name, "P");
                PMC    * const perl_meth = VTABLE_find_method(interp, sig_obj, perl_name);
                STRING * const sig_perl  = (STRING *)Parrot_run_meth_fromc_args(interp, perl_meth,
                        sig_obj, perl_name, "S");
                signatures = Parrot_str_append(interp, signatures, sig_perl);
                signatures = Parrot_str_append(interp, signatures, newline);
            }
            mem_sys_free(possibles);
            Parrot_ex_throw_from_c_args(interp, next, 1,
                "Ambiguous dispatch to multi '%Ss'. Ambiguous candidates had signatures:\n%Ss",
                    VTABLE_get_string(interp, candidates[0]->sub), signatures);
        }
    }
    else {
        /* Build PMC array of all possibles. */
        PMC * const results = pmc_new(interp, enum_class_ResizablePMCArray);
        INTVAL i;
        for (i = 0; i < possibles_count; i++)
            VTABLE_push_pmc(interp, results, possibles[i]->sub);
        mem_sys_free(possibles);

        /* If nothing was found at all, then supply the proto or junction auto-threader
         * if there is one. */
        if (!PMC_IS_NULL(junctional_res))
            VTABLE_push_pmc(interp, results, junctional_res);
        else if (possibles_count == 0 && !PMC_IS_NULL(proto))
            VTABLE_push_pmc(interp, results, proto);

        /* If we didn't depend upon constraints at all, then we can cache it. */
        if (pure_type_result) {
            if (!cache) {
                cache = Parrot_mmd_cache_create(interp);
                SETATTR_Perl6MultiSub_cache_many(interp, self, cache);
            }
            Parrot_mmd_cache_store_by_values(interp, cache, "", pos_args, results);
        }

        return results;
    }
}


/*

=item C<static PMC *find_many_candidates_with_arg_list(PARROT_INTERP, PMC *self, PMC *pos_args, PMC *named_args)>

Uses the given argument list to find all possible candidates that we could run, sorted
in order of preference.

=cut

*/
static PMC *find_many_candidates_with_arg_list(PARROT_INTERP, PMC *SELF, PMC *pos_args, PMC *named_args) {
    candidate_info **candidates = NULL;
    PMC             *unsorted;
    PMC             *proto;
    PMC             *results    = PMCNULL;
    MMD_Cache       *cache;

    /* Need to make sure a wobload of globals don't get destroyed. */
    PMC      * const saved_ccont       = interp->current_cont;
    opcode_t * const current_args      = interp->current_args;
    opcode_t * const current_params    = interp->current_params;
    opcode_t * const current_returns   = interp->current_returns;
    PMC      * const args_signature    = interp->args_signature;
    PMC      * const params_signature  = interp->params_signature;
    PMC      * const returns_signature = interp->returns_signature;

    /* See if we have a cache entry. */
    GETATTR_Perl6MultiSub_cache_many(interp, SELF, cache);
    if (cache)
        results = Parrot_mmd_cache_lookup_by_values(interp, cache, "", pos_args);
    if (PMC_IS_NULL(results)) {
        /* Make sure that we have a candidate list built. */
        GETATTR_Perl6MultiSub_candidates_sorted(interp, SELF, candidates);
        GETATTR_Perl6MultiSub_candidates(interp, SELF, unsorted);
        GETATTR_Perl6MultiSub_proto(interp, SELF, proto);

        if (!candidates) {
            candidates = sort_candidates(interp, unsorted, &proto);
            SETATTR_Perl6MultiSub_candidates_sorted(interp, SELF, candidates);
            SETATTR_Perl6MultiSub_proto(interp, SELF, proto);
        }

        if (!candidates)
            Parrot_ex_throw_from_c_args(interp, NULL, 1,
                "Failed to build candidate list");

        /* Now do the dispatch on the args we have been supplied with, and
         * get back a PMC array of possibles. */
        results = do_dispatch(interp, SELF, candidates, proto, pos_args, named_args,
                 MMD_MANY_RESULTS, VTABLE_elements(interp, unsorted), NULL, cache);
    }

    /* Restore stuff that might have got overwriten by calls during the
     * dispatch algorithm. */
    interp->current_cont      = saved_ccont;
    interp->current_args      = current_args;
    interp->current_params    = current_params;
    interp->current_returns   = current_returns;
    interp->args_signature    = args_signature;
    interp->params_signature  = params_signature;
    interp->returns_signature = returns_signature;

    return results;
}


/*

=item C<PMC *get_all_candidates_with_cur_args(PARROT_INTERP, PMC *self)>

Uses the arguments currently being passed to find all possible candidates that we
could run, sorted in order of preference. This is made available for calling by
the method dispatcher.

=cut

*/
PMC *get_all_candidates_with_cur_args(PARROT_INTERP, PMC *multi) {
    PMC *pos_args, *named_args;
    get_args(interp, &pos_args, &named_args);
    return find_many_candidates_with_arg_list(interp, multi, pos_args, named_args);
}


/*

=item C<static int assert_invokable(PARROT_INTERP, PMC *value)>

Checks if a PMC is invokable; returns a true value if so and a false value if
not.

=cut

*/
static int check_invokable(PARROT_INTERP, PMC *value) {
    STRING * const _sub = CONST_STRING(interp, "Sub");
    STRING * const _nci = CONST_STRING(interp, "NCI");
    return VTABLE_isa(interp, value, _sub) || VTABLE_isa(interp, value, _nci);
}

/*

=back

=head1 ATTRIBUTES

=over 4

=item candidates

Unsorted list of all candidates.

=item candidates_sorted

C array of canididate_info structures. It stores a sequence of candidates
length one or greater that are tied, followed by a NULL, followed by the next
bunch that are less narrow but tied and so forth. It is terminated by a double
NULL.

=item cache

A multiple dispatch cache, which memorizes the types we were invoked with so
we can dispatch more quickly.

=item proto

The proto that is in effect.

=back

=head1 METHODS

=over 4

=cut

*/
static  PMC *  Parrot_Perl6MultiSub_clone(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Perl6MultiSub_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Perl6MultiSub_elements(PARROT_INTERP, PMC *pmc);
static  PMC *  Parrot_Perl6MultiSub_get_iter(PARROT_INTERP, PMC *pmc);
static  PMC *  Parrot_Perl6MultiSub_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *p);
static  PMC *  Parrot_Perl6MultiSub_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL i);
static  PMC *  Parrot_Perl6MultiSub_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *s);
static  STRING *  Parrot_Perl6MultiSub_get_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Perl6MultiSub_init(PARROT_INTERP, PMC *pmc);
static  opcode_t  * Parrot_Perl6MultiSub_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  void  Parrot_Perl6MultiSub_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Perl6MultiSub_push_pmc(PARROT_INTERP, PMC *pmc, PMC *sub);
static  void Parrot_Perl6MultiSub_nci_find_possible_candidates(PARROT_INTERP, PMC *pmc);
static  void Parrot_Perl6MultiSub_nci_push(PARROT_INTERP, PMC *pmc);
static  void Parrot_Perl6MultiSub_nci_candidates(PARROT_INTERP, PMC *pmc);
PARROT_DYNEXT_EXPORT void    Parrot_Perl6MultiSub_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Perl6MultiSub_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Perl6MultiSub_get_vtable(PARROT_INTERP);
PARROT_DYNEXT_EXPORT void    Parrot_Perl6MultiSub_ro_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Perl6MultiSub_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Perl6MultiSub_ro_get_vtable(PARROT_INTERP);
static  PMC * 
Parrot_Perl6MultiSub_clone(PARROT_INTERP, PMC *pmc)
{

    PMC * const copy = pmc_new(interp, pmc->vtable->base_type);
    PMC *unsorted;
    GETATTR_Perl6MultiSub_candidates(interp, pmc, unsorted);
    unsorted = VTABLE_clone(interp, unsorted);
    SETATTR_Perl6MultiSub_candidates(interp, copy, unsorted);
    return copy;
}
static  void 
Parrot_Perl6MultiSub_destroy(PARROT_INTERP, PMC *pmc)
{

    candidate_info **candidates = NULL;
    MMD_Cache *cache_single;
    MMD_Cache *cache_many;

    /* If we built a sorted candidate list, free that. */
    GETATTR_Perl6MultiSub_candidates_sorted(interp, pmc, candidates);
    if (candidates) {
        candidate_info **cur_candidate = candidates;
        while (cur_candidate[0] || cur_candidate[1]) {
            if (*cur_candidate)
                mem_sys_free(*cur_candidate);
            cur_candidate++;
        }
        mem_sys_free(candidates);
    }

    /* Free the cache. */
    GETATTR_Perl6MultiSub_cache_single(interp, pmc, cache_single);
    if (cache_single)
        Parrot_mmd_cache_destroy(interp, cache_single);
    GETATTR_Perl6MultiSub_cache_many(interp, pmc, cache_many);
    if (cache_many)
        Parrot_mmd_cache_destroy(interp, cache_many);

    /* Free memory associated with this PMC's underlying struct. */
    mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
}
static  INTVAL 
Parrot_Perl6MultiSub_elements(PARROT_INTERP, PMC *pmc)
{

    PMC *candidates;
    GETATTR_Perl6MultiSub_candidates(interp, pmc, candidates);
    return VTABLE_elements(interp, candidates);
}
static  PMC * 
Parrot_Perl6MultiSub_get_iter(PARROT_INTERP, PMC *pmc)
{

    PMC *candidates;
    GETATTR_Perl6MultiSub_candidates(interp, pmc, candidates);
    return VTABLE_get_iter(interp, candidates);
}
static  PMC * 
Parrot_Perl6MultiSub_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *p)
{

    PMC *candidates;
    GETATTR_Perl6MultiSub_candidates(interp, pmc, candidates);
    return VTABLE_get_pmc_keyed(interp, candidates, p);
}
static  PMC * 
Parrot_Perl6MultiSub_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL i)
{

    PMC *candidates;
    GETATTR_Perl6MultiSub_candidates(interp, pmc, candidates);
    return VTABLE_get_pmc_keyed_int(interp, candidates, i);
}
static  PMC * 
Parrot_Perl6MultiSub_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *s)
{

    PMC *candidates;
    GETATTR_Perl6MultiSub_candidates(interp, pmc, candidates);
    return VTABLE_get_pmc_keyed_str(interp, candidates, s);
}
static  STRING * 
Parrot_Perl6MultiSub_get_string(PARROT_INTERP, PMC *pmc)
{

    PMC *candidates;
    GETATTR_Perl6MultiSub_candidates(interp, pmc, candidates);
    if (VTABLE_elements(interp, candidates) > 0)
        return VTABLE_get_string(interp, VTABLE_get_pmc_keyed_int(interp, candidates, 0));
    else
        return CONST_STRING(interp, "<anon>");
}
static  void 
Parrot_Perl6MultiSub_init(PARROT_INTERP, PMC *pmc)
{

    /* Allocate the underlying struct and make candidate list an empty
     * ResizablePMCArray. */
    PMC * const candidates = pmc_new(interp, enum_class_ResizablePMCArray);
    PMC_data(pmc) = mem_allocate_zeroed_typed(Parrot_Perl6MultiSub_attributes);
    SETATTR_Perl6MultiSub_candidates(interp, pmc, candidates);

    /* Need custom mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);
}
static  opcode_t  *
Parrot_Perl6MultiSub_invoke(PARROT_INTERP, PMC *pmc, void *next)
{

    PMC             *found      = PMCNULL;
    MMD_Cache       *cache;
    candidate_info **candidates = NULL;
    PMC             *unsorted;

    /* Need to make sure a wobload of globals don't get destroyed. */
    PMC      *saved_ccont       = interp->current_cont;
    opcode_t *current_args      = interp->current_args;
    opcode_t *current_params    = interp->current_params;
    opcode_t *current_returns   = interp->current_returns;
    PMC      *args_signature    = interp->args_signature;
    PMC      *params_signature  = interp->params_signature;
    PMC      *returns_signature = interp->returns_signature;

    /* Get arguments. */
    PMC *pos_args, *named_args;
    get_args(interp, &pos_args, &named_args);

    /* See if we have a cache entry. */
    GETATTR_Perl6MultiSub_cache_single(interp, pmc, cache);
    if (cache)
        found = Parrot_mmd_cache_lookup_by_values(interp, cache, "", pos_args);
    if (PMC_IS_NULL(found)) {
        PMC *proto;

        /* Make sure that we have a candidate list built. */
        GETATTR_Perl6MultiSub_candidates_sorted(interp, pmc, candidates);
        GETATTR_Perl6MultiSub_candidates(interp, pmc, unsorted);
        GETATTR_Perl6MultiSub_proto(interp, pmc, proto);

        if (!candidates) {
            candidates = sort_candidates(interp, unsorted, &proto);
            SETATTR_Perl6MultiSub_candidates_sorted(interp, pmc, candidates);
            SETATTR_Perl6MultiSub_proto(interp, pmc, proto);
        }

        if (!candidates)
            Parrot_ex_throw_from_c_args(interp, next, 1,
                "Failed to build candidate list");

        /* Now do the dispatch on the args we are being invoked with;
         * if it can't find anything, it will throw the required exception. */
        found = do_dispatch(interp, pmc, candidates, proto, pos_args, named_args,
                MMD_ONE_RESULT, VTABLE_elements(interp, unsorted), (opcode_t *)next, cache);
    }

    /* Restore stuff that might have got overwriten by calls during the
     * dispatch algorithm. */
    interp->current_cont      = saved_ccont;
    interp->current_args      = current_args;
    interp->current_params    = current_params;
    interp->current_returns   = current_returns;
    interp->args_signature    = args_signature;
    interp->params_signature  = params_signature;
    interp->returns_signature = returns_signature;

    /* Invoke the winner. */
    return VTABLE_invoke(interp, found, next);
}
static  void 
Parrot_Perl6MultiSub_mark(PARROT_INTERP, PMC *pmc)
{

    PMC *candidates;
    MMD_Cache *cache_single, *cache_many;
    GETATTR_Perl6MultiSub_candidates(interp, pmc, candidates);
    GETATTR_Perl6MultiSub_cache_single(interp, pmc, cache_single);
    GETATTR_Perl6MultiSub_cache_many(interp, pmc, cache_many);
    if (!PMC_IS_NULL(candidates))
        Parrot_gc_mark_PObj_alive(interp, (PObj*)candidates);
    if (cache_single)
        Parrot_mmd_cache_mark(interp, cache_single);
    if (cache_many)
        Parrot_mmd_cache_mark(interp, cache_many);
}
static  void 
Parrot_Perl6MultiSub_push_pmc(PARROT_INTERP, PMC *pmc, PMC *sub)
{

    PMC *candidates;
    MMD_Cache *cache;

    /* Make sure it's invokable. */
    if (!check_invokable(interp, sub))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Cannot add non-Sub PMC to a MultiSub.");

    /* Add it to the candidates list. */
    GETATTR_Perl6MultiSub_candidates(interp, pmc, candidates);
    VTABLE_push_pmc(interp, candidates, sub);

    /* Invalidate the sorted list - we'll need to re-build it. */
    SETATTR_Perl6MultiSub_candidates_sorted(interp, pmc, NULL);

    /* Invalidate the caches. */
    GETATTR_Perl6MultiSub_cache_single(interp, pmc, cache);
    if (cache)
        Parrot_mmd_cache_destroy(interp, cache);
    cache = NULL;
    SETATTR_Perl6MultiSub_cache_single(interp, pmc, cache);
    GETATTR_Perl6MultiSub_cache_many(interp, pmc, cache);
    if (cache)
        Parrot_mmd_cache_destroy(interp, cache);
    cache = NULL;
    SETATTR_Perl6MultiSub_cache_many(interp, pmc, cache);
}
static  void
Parrot_Perl6MultiSub_nci_find_possible_candidates(PARROT_INTERP, PMC *pmc)
{
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 3 };
    opcode_t _param_indexes[]     = { 0, 1, 2 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 34);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 546);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;



    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* pos_args = CTX_REG_PMC(_ctx, 1);
    PMC* named_args = CTX_REG_PMC(_ctx, 2);


    /* BEGIN PMETHOD BODY */
    {

    PMC *results = find_many_candidates_with_arg_list(interp, pmc, pos_args, named_args);
        {
    /*BEGIN RETURN PMC *results */
    /*BEGIN GENERATED ACCESSORS */
    CTX_REG_PMC(_ctx, 0) = results;

    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto find_possible_candidates_returns;
    /*END RETURN PMC *results */
    }


    }
    goto no_return;
    /* END PMETHOD BODY */

find_possible_candidates_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
}
static  void
Parrot_Perl6MultiSub_nci_push(PARROT_INTERP, PMC *pmc)
{
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;



    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* candidate = CTX_REG_PMC(_ctx, 1);


    /* BEGIN PMETHOD BODY */
    {

    VTABLE_push_pmc(interp, pmc, candidate);
        {
    /*BEGIN RETURN  */
    /*BEGIN GENERATED ACCESSORS */

    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);

    goto push_returns;
    /*END RETURN  */
    }


    }
    goto no_return;
    /* END PMETHOD BODY */

push_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
}
static  void
Parrot_Perl6MultiSub_nci_candidates(PARROT_INTERP, PMC *pmc)
{
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;



    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(_ctx, 0);


    /* BEGIN PMETHOD BODY */
    {

    PMC *candidates;
    GETATTR_Perl6MultiSub_candidates(interp, pmc, candidates);
        {
    /*BEGIN RETURN PMC *candidates */
    /*BEGIN GENERATED ACCESSORS */
    CTX_REG_PMC(_ctx, 0) = candidates;

    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto candidates_returns;
    /*END RETURN PMC *candidates */
    }


    }
    goto no_return;
    /* END PMETHOD BODY */

candidates_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
}
#include "pmc_default.h"

PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_Perl6MultiSub_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Perl6MultiSub_clone;
    vt->destroy = Parrot_Perl6MultiSub_destroy;
    vt->elements = Parrot_Perl6MultiSub_elements;
    vt->get_iter = Parrot_Perl6MultiSub_get_iter;
    vt->get_pmc_keyed = Parrot_Perl6MultiSub_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Perl6MultiSub_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Perl6MultiSub_get_pmc_keyed_str;
    vt->get_string = Parrot_Perl6MultiSub_get_string;
    vt->init = Parrot_Perl6MultiSub_init;
    vt->invoke = Parrot_Perl6MultiSub_invoke;
    vt->mark = Parrot_Perl6MultiSub_mark;
    vt->push_pmc = Parrot_Perl6MultiSub_push_pmc;
    vt->attr_size = 0;

    return vt;
}


PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_Perl6MultiSub_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Perl6MultiSub_clone;
    vt->destroy = Parrot_Perl6MultiSub_destroy;
    vt->elements = Parrot_Perl6MultiSub_elements;
    vt->get_iter = Parrot_Perl6MultiSub_get_iter;
    vt->get_pmc_keyed = Parrot_Perl6MultiSub_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Perl6MultiSub_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Perl6MultiSub_get_pmc_keyed_str;
    vt->get_string = Parrot_Perl6MultiSub_get_string;
    vt->init = Parrot_Perl6MultiSub_init;
    vt->invoke = Parrot_Perl6MultiSub_invoke;
    vt->mark = Parrot_Perl6MultiSub_mark;
    vt->attr_size = 0;

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Perl6MultiSub_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_MultiSub_get_vtable(interp);
    Parrot_Perl6MultiSub_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Perl6MultiSub_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_MultiSub_ro_get_vtable(interp);
    Parrot_Perl6MultiSub_ro_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Perl6MultiSub_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_MultiSub_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Perl6MultiSub", 13, NULL, 0));
    return mro;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Perl6MultiSub_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_MultiSub_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Perl6MultiSub")), PMCNULL);
    return isa;
}

void
Parrot_Perl6MultiSub_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Isize :pmc_array Iresize_threshold Fcandidates :candidates_sorted :cache_single :cache_many Fproto ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Perl6MultiSub_get_vtable(interp);
        vt->base_type      = -1;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->base_type    = entry;
        vt->whoami       = string_make(interp, "Perl6MultiSub", 13,
                                       "ascii", PObj_constant_FLAG|PObj_external_FLAG);
        vt->provides_str = Parrot_str_append(interp, vt->provides_str,
            string_make(interp, "scalar", 6, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG));

        vt->isa_hash     = Parrot_Perl6MultiSub_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Perl6MultiSub_ro_get_vtable(interp);
            vt_ro->base_type      = -1;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Perl6MultiSub_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Perl6MultiSub_nci_find_possible_candidates), CONST_STRING_GEN(interp, "find_possible_candidates"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Perl6MultiSub_nci_push), CONST_STRING_GEN(interp, "push"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Perl6MultiSub_nci_candidates), CONST_STRING_GEN(interp, "candidates"));
        {
        }
    } /* pass */
} /* Parrot_Perl6MultiSub_class_init */
/*
 * This load function will be called to do global (once) setup
 * whatever is needed to get this extension running
 */


PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_perl6multisub_load(PARROT_INTERP); /* don't warn */
PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_perl6multisub_load(PARROT_INTERP)
{
    Parrot_String whoami;
    Parrot_PMC    pmc;
    Parrot_Int typePerl6MultiSub;
    int pass;

    /* create a library PMC */
    pmc = constant_pmc_new(interp, enum_class_ParrotLibrary);

    /* TODO: stuff some info into this PMC's props */

    /* for all PMCs we want to register: */
    whoami = CONST_STRING_GEN(interp, "Perl6MultiSub");
    typePerl6MultiSub = pmc_register(interp, whoami);

    /* do class_init code */
    for (pass = 0; pass <= 1; ++pass) {
        Parrot_Perl6MultiSub_class_init(interp, typePerl6MultiSub, pass);
    }
    return pmc;
}



/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
